"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const sqlite3_1 = __importDefault(require("sqlite3"));
const Sqlite3Statement_1 = require("./sqlite3/Sqlite3Statement");
exports.Sqlite3Statement = Sqlite3Statement_1.Sqlite3Statement;
const Sqlite3Database_1 = require("./sqlite3/Sqlite3Database");
exports.Sqlite3Database = Sqlite3Database_1.Sqlite3Database;
const Sqlite3_interfaces_1 = require("./interfaces/Sqlite3.interfaces");
exports.Sqlite3 = Sqlite3_interfaces_1.Sqlite3;
async function open(config) {
    let driver = config.driver || sqlite3_1.default.Database;
    if (!config.driver && config.cached) {
        driver = sqlite3_1.default.cached.Database;
    }
    if (config.verbose) {
        sqlite3_1.default.verbose();
    }
    const db = new Sqlite3Database_1.Sqlite3Database({
        ...config,
        driver
    });
    await db.open();
    return db;
}
exports.open = open;
//# sourceMappingURL=index.js.map